#!/usr/bin/python
# coding=UTF-8
import urllib
import simplejson as json
import sys
import dbus
import time

# OPTIONS START
timeout = 30
board = "lor"
thread = "16218"
#OPTIONS END

err = 1
while err:
  try:
    info = urllib.urlopen("http://dobrochan.ru/api/thread/info/%s/%s.json"%(board,thread))
    messages = urllib.urlopen("http://dobrochan.ru/%s/res/%s.json"%(board,thread))
    infoDump = info.read()
    messDump = messages.read()
    infoObj = json.loads(infoDump)
    messObj = json.loads(messDump)
    err = 0
  except:
    print u"Не могу получить данные... Повтор"
    time.sleep(timeout)
    err = 1
print u"В треде >>%s/%s \"%s\" найдено: сообщений - %s, файлов - %s. Последнее изменение произведено в %s"%(
  board,
  thread,
  infoObj['boards'][board]['threads'][0]['title'],
  infoObj['boards'][board]['threads'][0]['posts_count'],
  infoObj['boards'][board]['threads'][0]['files_count'],
  infoObj['boards'][board]['threads'][0]['last_modified']
)
lastId = messObj['boards'][board]['threads'][0]['posts'].pop()['display_id']
posts = []
while 1:
  try:
    messages = urllib.urlopen("http://dobrochan.ru/api/thread/new/%s/%s.json?last_post=%s"%(board,thread,lastId))
    messDump = messages.read()
    messObj = json.loads(messDump)
  except:
    print u"Ошибка подключения.. Повтор"
    time.sleep(timeout)
    continue
  if 'posts' in messObj['boards'][board]['threads'][0]:
    posts = messObj['boards'][board]['threads'][0]['posts']
  else:
    posts = []
  for post in posts:
    lastId = post['display_id']
    print post['message']
    mesFile = post['files']
    if mesFile and ('thumb' in mesFile[0].keys()):
      print "Thumb: http://dobrochan.ru/%s"%mesFile[0]['thumb']
      mesThumb = urllib.urlopen("http://dobrochan.ru/%s"%mesFile[0]['thumb'])
      mesThumbData = mesThumb.read()
    else:
      mesThumbData = [0,0,0,0]
    dbus.SessionBus().get_object("org.kde.knotify", "/Notify").event(
    "warning",
    "kde",
    [],
    infoObj['boards'][board]['threads'][0]['title'],
    u"Новое сообщение %s:<br/>%s"%(post['date'],post['message']),
    mesThumbData,
    [],
    0,
    0,
    dbus_interface="org.kde.KNotify")
  time.sleep(timeout)